unit UPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FMTBcd, DBXpress, DB, StdCtrls, Mask, DBCtrls, DBClient,
  Provider, SqlExpr, ExtCtrls, Grids, DBGrids;

type
  TForm1 = class(TForm)
    sqlCadastro: TSQLDataSet;
    SQLConnection: TSQLConnection;
    dspCadastro: TDataSetProvider;
    cdsCadastro: TClientDataSet;
    cdsCadastroCAMPO_PK: TIntegerField;
    cdsCadastroNOME: TStringField;
    cdsCadastroALTERADO: TStringField;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    dtsCadastro: TDataSource;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    DBNavigator1: TDBNavigator;
    cdsDeleteFile: TClientDataSet;
    cdsDeleteFileDelete: TStringField;
    DBGrid1: TDBGrid;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    sqlCadastroCAMPO_PK: TIntegerField;
    sqlCadastroNOME: TStringField;
    sqlCadastroALTERADO: TStringField;
    sqlCadastroHORA: TSQLTimeStampField;
    cdsCadastroHORA: TSQLTimeStampField;
    procedure cdsCadastroAfterPost(DataSet: TDataSet);
    procedure dspCadastroBeforeUpdateRecord(Sender: TObject;
      SourceDS: TDataSet; DeltaDS: TCustomClientDataSet;
      UpdateKind: TUpdateKind; var Applied: Boolean);
    procedure cdsCadastroReconcileError(DataSet: TCustomClientDataSet;
      E: EReconcileError; UpdateKind: TUpdateKind;
      var Action: TReconcileAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.cdsCadastroAfterPost(DataSet: TDataSet);
begin
  cdsCadastro.ApplyUpdates(0);
end;

procedure TForm1.dspCadastroBeforeUpdateRecord(Sender: TObject;
  SourceDS: TDataSet; DeltaDS: TCustomClientDataSet;
  UpdateKind: TUpdateKind; var Applied: Boolean);
begin
  // Se for um novo registro ou alteracao, marca o registro como Alterado (S)
  if UpdateKind in [ukInsert,ukModify] then
  begin
    DeltaDS.FieldByName('ALTERADO').NewValue := 'S';
    DeltaDS.FieldByName('HORA').NewValue := NOW;
  end

  // Se estiver apagando, ele gera um delete para o registro
  else if UpdateKind = ukDelete then
  begin
    with cdsDeleteFile do
    begin
      if Not Active then Open;
      Insert;
      FieldByName('delete').AsString :=
        'delete from TESTE '+
        ' where CAMPO_PK = '+ DeltaDS.FieldByName('CAMPO_PK').AsString +
        '   and HORA < '''+ FormatDateTime('mm/dd/yyyy hh:nn:ss',now) +'''';
      Post;
    end;
  end
end;

procedure TForm1.cdsCadastroReconcileError(DataSet: TCustomClientDataSet;
  E: EReconcileError; UpdateKind: TUpdateKind;
  var Action: TReconcileAction);
begin
  // Caso ocorra algum erro quando for gravar no banco, apenas informa o usurio
  raise Exception.Create(E.message);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  cdsCadastro.Open;
  cdsDeleteFile.Open;
end;

end.
