{ Invokable implementation File for TwsAtualizar which implements IwsAtualizar }

unit wsAtualizarImpl;

interface

uses InvokeRegistry, Types, XSBuiltIns, wsAtualizarIntf, DBClient, SysUtils,
  classes, UDmCadastro, Variants;

type

  { TwsAtualizar }
  TwsAtualizar = class(TInvokableClass, IwsAtualizar)
  public
    procedure Atualiza(var Data: OleVariant);stdcall;
    procedure Delete(var Data: OleVariant);stdcall;
  end;

implementation

{ TwsAtualizar }

procedure TwsAtualizar.Atualiza(var Data: OleVariant);
var
  lt_Cds: TClientDataSet;
  FDmCadastro: TDmCadastro;
begin

  // Cria um DataSet para manipular os dados recebidos
  lt_Cds := TClientDataSet.Create(nil);

  // Cria uma instancia do DMCadastro
  FDmCadastro := TDmCadastro.Create(Nil);
  try
    try
      lt_Cds.Data := Data;
      with lt_Cds do
      begin
        if not Active then Open;
        First;
        //Percorre o DataSet atualizando as informaoes contidas
        while Not Eof do
        begin
          FDmCadastro.spAtualiza.Params.ParamByName('PCAMPO_PK').AsInteger := FieldByName('CAMPO_PK').AsInteger;
          FDmCadastro.spAtualiza.Params.ParamByName('PNOME').AsString := FieldByName('NOME').AsString;
          FDmCadastro.spAtualiza.Params.ParamByName('PHORA').AsSQLTimeStamp := FieldByName('HORA').AsSQLTimeStamp;
          FDmCadastro.spAtualiza.ExecProc;
          // Caso algum erro ocorra, o registro nao ser deletado
          // O usurio ir saber que aquele registro por algum motivo
          // nao foi atualizado
          Delete;
        end;
      end;
    except
      on E: Exception do
      begin
        raise Exception.Create('Erro from server:'+ #$D#$A + E.message);
      end;
    end;
  finally
    Data := lt_Cds.Data;
    lt_Cds.Close;
    FreeAndNil(lt_Cds);
    FreeAndNil(FDmCadastro);
  end;
end;

procedure TwsAtualizar.Delete(var Data: OleVariant);
var
  lt_Cds: TClientDataSet;
  FDmCadastro: TDmCadastro;
begin
  lt_Cds := TClientDataSet.Create(nil);
  FDmCadastro := TDmCadastro.Create(Nil);
  try
    try
      lt_Cds.Data := Data;
      with lt_Cds do
      begin
        if not Active then Open;
        First;
        while Not Eof do
        begin
          //Executa direto pelo SQLConnection, dispensando um DataSet
          FDmCadastro.SQLConnection.Execute(lt_Cds.Fields[0].AsString,Nil);
          Delete;
        end;
      end;
    except
      on E: Exception do
      begin
        raise E;
      end;
    end;
  finally
    Data := lt_Cds.Data;
    lt_Cds.Close;
    FreeAndNil(lt_Cds);
    FreeAndNil(FDmCadastro);
  end;
end;

initialization
  { Invokable classes must be registered }
  InvRegistry.RegisterInvokableClass(TwsAtualizar);

end.
